精华内容
下载资源
问答
  • python中异常捕获的完整语法 try: # 尝试执行的代码 pass except 错误类型: #针对错误类型,对应的代码处理 except Except as e: # e 是一个变量 print(“未知错误”, e) else: # 没有异常才会执行的代码 pass ...

    python中异常捕获的完整语法

     try:
     	# 尝试执行的代码
     	pass
     except 错误类型:
     	#针对错误类型,对应的代码处理
     except Except as e:   # e 是一个变量,用于记录错误类型
     	print("未知错误", e)
     else:
     	# 没有异常才会执行的代码
     	pass
     finally:
     	# 无论是否有异常都会执行的代码
     	pass
    

    pass 是一个空语句,不做任何事,一般用做占位语句,是为了保持程序运行的完整性。

    python抛出异常

    • python使用raise语句抛出一个指定异常
    raise TypeError("参数类型不正确")
    

    代码执行结果为:
    在这里插入图片描述

    python assert(断言)

    • python assert(断言)用于判断一个表达式,只有在表达式结果为False的时候触发异常
    1. assert语法格式:
        assert 表达式
    

    等价于:

    if not 表达式:
    	raise AssertionError
    
    1. assert 后面可以加参数:
    assert 表达式 [, 参数]
    

    等价于:

    if not 表达式:
    	raise AssertionError(参数)
    
    • 实例1:
    assert True
    

    代码执行结果:
    在这里插入图片描述

    • 实例2:
    assert False
    

    代码执行结果:
    在这里插入图片描述

    • 实例3:
    assert 1 == 1
    

    代码执行结果:
    在这里插入图片描述

    • 实例4:
    assert 1 == 2
    

    代码执行结果:
    在这里插入图片描述

    • 实例5:
    assert 1 == 2, "1 和 2 不相等"
    

    代码执行结果:
    在这里插入图片描述

    python常见的异常类型

    • BaseException 是所有异常的基类
    • Exception 是常规错误的基类

    python标准异常类型

    异常名称 异常描述
    SystemExit 解释器请求退出
    Keyboardlnterrupt 用户请求中断执行(通常输入Ctrl + C)
    Stoplteration 迭代器没有更多的值
    StandardError 所有的内建标准异常的基类
    GeneratorExit 生成器(generator)发生异常来通知退出
    ArithmeticError 所有数值计算错误的基类
    FloatingPointError 浮点数计算错误
    OverflowError 数值运算超出最大限制
    ZeroDivisionError 除零错误
    AssertionError 断言语句失败
    AttributeError 对象没有这个属性
    EOFError 没有内建输入,到达EOF标记
    EnvironmentError 操作系统错误的基类
    IOError 输入/输出操作失败
    OSError 操作系统错误
    WindowsError 系统调用错误
    ImportError 导入模块/对象失败
    LookupError 无效数据查询的基类
    IndexError 序列中没有此索引(index)
    KeyError 映射中没有这个键
    MemorryError 内存溢出错误
    NameError 未声明/初始化对象(没有属性)
    UnboundLocalError 访问未初始化的本地变量
    ReferenceError 弱引用(weak reference)试图访问已经回收的对象
    RuntimeError 一般运行时错误
    NotlmplementedError 尚未实现的方法
    SyntaxError python语法错误
    IndentationError 缩进错误
    TabError Tab和空格混用
    SystemError 一般解释器系统错误
    TypeError 对类型无效的操作
    ValueError 传入无效的参数
    UnicodeError Unicode 相关的错误
    UnicodeDecodeError Unicode 解码时错误
    UnicodeEncodeError Unicode 编码时错误
    UnicodeTranslateError Unicode 转换时错误

    警告异常

    • Warning 警告的基类
    警告异常 异常描述
    DeprecationWarning 关于被弃用的特征的警告
    FutureWarning 关于构造将来语义会有改变的警告
    OverflowWarning 旧的关于自动提升为长整形(long)的警告
    PendingDeprecationWarning 关于特征将会被遗弃的警告
    RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
    SyntaxWarning 可疑的语法的警告
    UserWarning 用户代码生成的警告
    展开全文
  • python中异常的姓名

    万次阅读 2019-05-06 17:48:20
    IOError 输入/输出异常;基本上是无法打开文件 ImportError 无法引入模块或包;基本上是路径问题或名称错误 IndentationError 语法错误(的子类) ;代码没有正确对齐 IndexError 下标索引超出序列边界,比如当x只有...

    AttributeError 试图访问一个对象没有的树形,比如foo.x,但是foo没有属性x
    IOError 输入/输出异常;基本上是无法打开文件
    ImportError 无法引入模块或包;基本上是路径问题或名称错误
    IndentationError 语法错误(的子类) ;代码没有正确对齐
    IndexError 下标索引超出序列边界,比如当x只有三个元素,却试图访问x[5]
    KeyError 试图访问字典里不存在的键
    KeyboardInterrupt Ctrl+C被按下
    NameError 使用一个还未被赋予对象的变量
    SyntaxError Python代码非法,代码不能编译(个人认为这是语法错误,写错了)
    TypeError 传入对象类型与要求的不符合
    UnboundLocalError 试图访问一个还未被设置的局部变量,基本上是由于另有一个同名的全局变量,
    导致你以为正在访问它
    ValueError 传入一个调用者不期望的值,即使值的类型是正确的
    ArithmeticError
    AssertionError
    AttributeError
    BaseException
    BufferError
    BytesWarning
    DeprecationWarning
    EnvironmentError
    EOFError
    Exception
    FloatingPointError
    FutureWarning
    GeneratorExit
    ImportError
    ImportWarning
    IndentationError
    IndexError
    IOError
    KeyboardInterrupt
    KeyError
    LookupError
    MemoryError
    NameError
    NotImplementedError
    OSError
    OverflowError
    PendingDeprecationWarning
    ReferenceError
    RuntimeError
    RuntimeWarning
    StandardError
    StopIteration
    SyntaxError
    SyntaxWarning
    SystemError
    SystemExit
    TabError
    TypeError
    UnboundLocalError
    UnicodeDecodeError
    UnicodeEncodeError
    UnicodeError
    UnicodeTranslateError
    UnicodeWarning
    UserWarning
    ValueError
    Warning
    ZeroDivisionError

    使用异步加延时进行错误修复机器人的植入 来解决程序报错而自动中断的问题
    使用使用yield
    也就是说可以使用协成

    展开全文
  • 异常:执行过程出现问题导致程序无法执行,异常是因为程序出现了错误而在正常控制流意外采取的行为。 1.首先是引起异常发生的错误 2.然后是检测(和采取可能的措施)阶段 1.2 1.3 Python标准和自定义异常 ...

    一、基础知识
    1.1 错误和异常概念
    错误:
    1.语法错误:代码不符合解释器或者编译器语法
    2.逻辑错误:不完整或者不合法输入或者计算出现问题
    异常:执行过程中出现问题导致程序无法执行,异常是因为程序出现了错误而在正常控制流意外采取的行为。
    1.首先是引起异常发生的错误
    2.然后是检测(和采取可能的措施)阶段

    1.2
    1.3 Python标准和自定义异常
    标准异常:python内建异常,程序执行前就已经存在
    自定义异常:
    1.python允许自定义异常,用于描述python中没有涉及的异常情况
    2.自定义异常必须继承Exception类
    3.自定义异常只能主动触发

    1.4 python标准异常:
    异常名称 ——————————————描述
    BaseException :所有异常的基类
    KeyboardInterrupt : 用户中断执行(通常是输入^C)
    Exception :常规错误的基类
    StopIteration : 迭代器没有更多的值
    GeneratorExit : 生成器(generator)发生异常来通知退出
    SystemExit : Python 解释器请求退出
    StandardError : 所有的内建标准异常的基类
    ArithmeticError : 所有数值计算错误的基类
    FloatingPointError : 浮点计算错误
    OverflowError : 数值运算超出最大限制
    ZeroDivisionError : 除(或取模)零 (所有数据类型)
    AssertionError : 断言语句失败
    AttributeError : 对象没有这个属性
    EOFError :没有内建输入,到达EOF 标记
    EnvironmentError : 操作系统错误的基类
    IOError :输入/输出操作失败
    OSError :操作系统错误
    WindowsError: 系统调用失败
    ImportError:导入模块/对象失败
    LookupError 无效数据查询的基类
    IndexError 序列中没有没有此索引(index)
    KeyError 映射中没有这个键
    MemoryError 内存溢出错误(对于Python 解释器不是致命的)
    NameError 未声明/初始化对象 (没有属性)
    UnboundLocalError 访问未初始化的本地变量
    ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
    RuntimeError 一般的运行时错误
    NotImplementedError 尚未实现的方法
    SyntaxErrorPython 语法错误
    IndentationError 缩进错误
    TabErrorTab 和空格混用
    SystemError 一般的解释器系统错误
    TypeError 对类型无效的操作
    ValueError 传入无效的参数
    UnicodeErrorUnicode 相关的错误
    UnicodeDecodeError: Unicode 解码时的错误
    UnicodeEncodeError: Unicode 编码时错误
    UnicodeTranslateError:Unicode 转换时错误
    Warning::警告的基类
    DeprecationWarning:关于被弃用的特征的警告
    FutureWarning 关于构造将来语义会有改变的警告
    OverflowWarning 旧的关于自动提升为长整型(long)的警告
    PendingDeprecationWarning 关于特性将会被废弃的警告
    RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
    SyntaxWarning 可疑的语法的警告
    UserWarning 用户代码生成的警告

    二、 捕获异常
    2.1 try-except 语句
    ——定义了进行异常监控的一段代码,并且提供了处理异常的机制。
    try-except:异常处理
    try:
    try_suite
    except Exception [, e]:
    exception_block
    1.try用来捕获try_suite中的错误,并且将错误交给except处理
    2.except用来处理异常,如果异常处理和设置捕获异常一致,使用exception_block处理异常
    ——把多个except语句连接在一起,处理一个try块中可能发生的多种异常。
    1)try-except:处理多个异常
    try:
    try_suite
    except Exception1 [e]:
    exception_block1
    except Exception2 [e]:
    exception_block2
    except ExceptionN [e]:
    exception_blockN

    2)try-except–else使用(如果没有异常,执行else语句中的代码)
    try:
    try_suite
    except Exception1 [e]:
    exception_block1
    else:
    none_exception
    —— finally子句是无论是否检测到异常,都会执行的一段代码。可以丢掉except子句和else子句,单独使用try…finally,也可以配合except等使用。作用:为异常处理事件提供清理机制,用来关闭文件或者释放系统资源
    1)try-finally语句:
    try:
    try_suite
    finally:
    do_finally
    1.如果try语句没有捕获错误,代码执行do_finally语句
    2.如果try语句捕获错误,程序首先执行do_finally语句,然后将捕获到的错误交给python解释器处理

    2)try-except-finally使用:
    try:
    try_suite
    except:
    do_except
    finally:
    do_finally
    1.若try语句没有捕获异常,执行完try代码段后,执行finally
    2.若try捕获异常,首先执行except处理错误,然后执行finally

    3)try-except-else-finally使用:
    try:
    try_suite
    except:
    do_except
    else:
    do_else
    finally:
    do_finally
    1.若try语句没有捕获异常,执行完try代码块后,执行else代码块,最后执行finally
    2.若try捕获异常,首先执行except处理错误,然后执行finally

    三 、断言、触发异常
    3.1 断言(assert):是一句必须等价于布尔值为真的判定,发生异常也意味着表达式为假
    assert expression[,reason]
    执行该语句的时候,先判断表达式expression,如果表达式为真,则什么都不做;如果表达式不为真,则抛出异常。assert异常也可以被try块捕获。

    3.2 触发异常
    即主动引发异常,执行raise语句,Python会创建指定的异常类的一个对象,raise语句还可以对异常对象进行初始化的参数。
    raise [SomeException [, args [,traceback]]
    第一个参数,SomeException必须是一个异常类,或异常类的实例
    第二个参数是传递给SomeException的参数,必须是一个元组。这个参数用来传递关于这个异常的有用信息。
    第三个参数traceback很少用,主要是用来提供一个跟踪记录对象(traceback)

    四 、异常和sys模块、上下文管理
    4.1 异常和sys模块
    另一种获取异常信息的途径是通过sys模块中的exc_info()函数。该函数回返回一个三元组:(异常类,异常类的实例,跟踪记录对象)
    4.2 上下文管理(with语句)
    with context [as var]:
    with_suite
    1.with语句用来代替try-except-finally语句,是代码更加简洁;
    2.context表达式返回是一个对象;
    3.var用来保存context返回对象,单个返回值或者元祖;
    4.with_suite使用var变量来对context返回对象进行操作

    展开全文
  • Python中异常捕捉try..except...finally的使用

    万次阅读 多人点赞 2018-08-18 10:41:33
    Python开发 ,常见错误类型有两种 :语法错误和异常。语法错误是程序没有运行时,由开发IDE环境检测到错误,比如缩进错误,变量没有写完整,缺少:等解析错误。而异常就是指程序运行时检测到的错误,比如...

        Python开发中 ,常见错误类型有两种 :语法错误和异常。语法错误是程序没有运行时,由开发IDE环境检测到错误,比如缩进错误,变量没有写完整,缺少:等解析错误。而异常就是指程序运行时检测到的错误,比如ZeroDivisionError,分母为0的错1/0.比如“aaa”+4等错误。

         异常为什么需要处理?1.实际开发中不能直接讲代码的报错抛给用户,而是通过异常处理的形式给出提示。2.如果有异常不处理,程序会挂起,异常后的代码都不会执行。这样影响实际程序的使用。

    1.异常演示

    #异常类型1:
    print("准备open the file")
    f1 = open("aaa.txt","r")
    print("the file is open")
    '''文件不存在,程序报错,是代码形式反馈错误,实际开发给用户体验不好。
    准备open the file
        f1 = open("aaa.txt","r")
    FileNotFoundError: [Errno 2] No such file or directory: 'aaa.txt'
    '''
    #异常类型2
    num= 5
    print(num/0) 
    print(num/0) #ZeroDivisionError: division by zero
    ZeroDivisionError: division by zero

    2.异常处理:python中用 try...except... 捕获异常

    1.虽然try....except捕捉了异常 ,程序不会报代码的错误。但是注意异常代码后面的代码不会执行了,可以用try...finally替代。

    2.一个 try 语句可能包含多个except子句,分别来处理不同的特定的异常。但只有一个分支会被执行,类似else

    3.如果在执行try子句的过程中发生了异常,那么try子句余下的部分将被忽略。如果异常的类型和 except 之后的名称相符,那么对应的except子句将被执行。最后执行 try 语句之外的代码。

    #0.捕捉异常和不捕捉异常的区别在哪里?
    num = 5
    print(num/0)
    
    print("我是try之外的代码,你猜我会执行吗?哈哈哈")
    print("我是try之外的代码,你猜我会执行吗?呵呵呵呵")
    -------不捕捉异常的结果,异常代码后面的代码print都不会执行-------------------------------------
    Traceback (most recent call last):
      File "D:/pythoyworkspace/file_demo/Class_Demo/Exception_demo.py", line 3, in <module>
        print(num/0)
    ZeroDivisionError: division by zero
    ------------------捕捉异常的代码---------------------------------------------------------
    try:
        num = 5
        print(num/0)
    except Exception as ex_results:
        print("有情况")
        print("抓了一个异常:",ex_results)
    print("我是try之外的代码,你猜我会执行吗?哈哈哈")
    ==============捕捉异常后代码的执行结果:异常后的代码print会执行=============================
    有情况
    抓了一个异常: division by zero
    我是try之外的代码,你猜我会执行吗?哈哈哈
    我是try之外的代码,你猜我会执行吗?呵呵呵
    ------------------------------------------------------------------------------------------
    #1.异常处理:python中用 try...except... 捕获异常
    try:  #1.注意代码的缩进,隐患需要处理的代码放到try的缩进代码块里。
        print("准备open the file")
        f1 = open("aaa.txt","r")
        print("the file is open")
    except IOError: #except后面跟的是错误类型。
        print("很抱歉:你打开的文件不存在!")  
        #except缩进跟的是处理方式,把处理异常的代码,放在except中。如果没有处理方式可以直接用pass表示什么也不做.
    
    =========================================================================
    准备open the file
    很抱歉:你打开的文件不存在!
    
    #2.try--except同时处理多个异常类型
    try:
        num = 5
        print(num/0)
        print("准备open the file")
        f1 = open("aaa.txt","r")
        print("the file is open")
    except(IOError,ZeroDivisionError): #可以同时处理多个异常,各种类型用元组封装
        print("垃圾,程序有异常了")
    
    #3.如果不确定异常类型,可以except后面什么都不写。
    try:
        num = 5
        print(num/0)
        print("准备open the file")
        f1 = open("aaa.txt","r")
        print("the file is open")
    except:
        print("垃圾,程序有异常了")
    #4.打印异常类型,但是实际异常后面的代码不会执行 ,所以只能捕捉一个异常。
    try:
        f1 = open("aaa.txt", "r")
        print("the file is open")
        num = 5
        print(num/0)
        print("准备open the file")
    except (IOError,ZeroDivisionError) as ex_results: 
        print(ex_results)
    =========================================================================
    [Errno 2] No such file or directory: 'aaa.txt'
    
    #5.捕捉所有异常,这种情况适合不知道异常具体类型,但是又想存储打印异常类型 。
    try:
        num = 5
        print(num/0)
        f1 = open("aaa.txt", "r")
        print("the file is open")
        print("准备open the file")
    except Exception as ex_results:
        print("有情况")
        print("抓了一个异常:",ex_results)
    print("我是try之外的代码,你猜我会执行吗?哈哈哈")
    print("我是try之外的代码,你猜我会执行吗?呵呵呵呵")
    ==========================================================================
    有情况
    抓了一个异常: division by zero
    我是try之外的代码,你猜我会执行吗?哈哈哈
    我是try之外的代码,你猜我会执行吗?呵呵呵呵
    
    #6.try--except可以配上else,类似while else ,for else的使用
    try:
        num = input("请输入一个整数除数:")
        result = 100.0/int(num)
        print("商的结果是:%f"%result)
    except ZeroDivisionError as ex_results:
        print("有情况")
        print("抓了一个异常:",ex_results)
    else :
        print("恭喜,没有 错误")
    ==========================================================================
    请输入一个整数除数:6
    商的结果是:16.666667
    恭喜,没有 错误
    请输入一个整数除数:0
    有情况
    抓了一个异常: float division by zero
    
    

    3.异常捕捉:try ..except..finally 

    在程序中,如果一个段代码必须要执行,即无论异常是否产生都要执行,那么此时就需要使用finally。 比如文件关闭,释放锁,把数据库连接返还给连接池等,注意:finally是可选的选项。

    #1.try...except....finally的使用演示
    try:
        f1 = open("test.txt","rU")
        for i in f1:
            i=i.strip()
            print(i)
    except Exception as E_results:
        print("捕捉有异常:",E_results)
    finally: #finally的代码是肯定执行的,不管是否有异常,但是finally语块是可选的。
        f1.close
        print("我不管,我肯定要执行。")
    ------------------程序无异常会执行-----------------------------------
    ccccccccccd
    ddddddddddddddddd
    333343434343
    safsdfasdfsadfsa
    我不管,我肯定要执行。
    ------------------程序有异常还是会执行----------------------------------
    File "D:/pythoyworkspace/file_demo/Class_Demo/Exception_demo.py", line 44, in <module>
    捕捉有异常: [Errno 2] No such file or directory: 'tes2t.txt'
        f1.close
    我不管,我肯定要执行。
    NameError: name 'f1' is not defined
    
    #2.注意try..finally的使用,可以没有except。只有try...except.,try...except...finally这三种用法
    
    try:
        f1 = open("tes3t.txt","rU")
        for i in f1:
            i=i.strip()
            print(i)
    finally: #finally的代码是肯定执行的,不管是否有异常,但是finally语块是可选的。
        print("我不管,我肯定要执行。")
        f1.close
    -----------------------有异常的情况 ------------------------------------------------------
     File "D:/pythoyworkspace/file_demo/Class_Demo/Exception_demo.py", line 36, in <module>
    恭喜,没有 错误
        f1 = open("tes3t.txt","rU")
    我不管,我肯定要执行。
    FileNotFoundError: [Errno 2] No such file or directory: 'tes3t.txt'
    
    During handling of the above exception, another exception occurred:
    
    Traceback (most recent call last):
      File "D:/pythoyworkspace/file_demo/Class_Demo/Exception_demo.py", line 42, in <module>
        f1.close
    NameError: name 'f1' is not defined
    --------------------------无异常的情况----------------------------------------------------- 
    ccccccccccd
    ddddddddddddddddd
    333343434343
    safsdfasdfsadfsa
    我不管,我肯定要执行。

    4.异常处理事失败的情况:异常类似错误

    try:
        num = 5
        print(num/0) #ZeroDivisionError: division by zero
    except IOError:
        print("报错了,分母不能为0")
    '''虽然捕捉处理了异常,但是为什么用呢?
    print(num/0) #ZeroDivisionError: division by zero
    ZeroDivisionError: division by zero
    '''
    注意:因为异常类型不对,异常类型要很精确的,否则没有用。如果不确定异常类型,可以直接什么都不写
    try:
        num = 5
        print(num/0) #ZeroDivisionError: division by zero
    except ZeroDivisionError:
        print("报错了,分母不能为0")
    -------------------------------------------------------
    报错了,分母不能为0
    
    #如果不知道异常是什么类型,可以不写。但是如果写了异常类型,必须是精确的
    try:
        num = 5
        print(num/0) #ZeroDivisionError: division by zero
    except :
        print("报错了,分母不能为0")
    -------------------------------------------------------
    报错了,分母不能为0

    5.案例演示:异常传递的情况

    def test1():
        print("----test1-1----")
        print(num)
        print("----test1-2----")
    
    def test2():
        print("----test2-1----")
        test1()
        print("----test2-2----")
    
    def test3():
        try:
            print("----test3-1----")
            test1()
            print("----test3-2----")
        except Exception as result:
            print("捕获到了异常,信息是:%s" % result)
    
        print("----test3-3---")
    #注意分析执行的结果
    test3()
    print("------test3执行完了,分割一下-----")
    test2()
    
    ====================执行结果如下=======================================================
    ----test3-1----
    Traceback (most recent call last):
    ----test1-1----
      File "D:/pythoyworkspace/file_demo/Class_Demo/Exception_demo.py", line 23, in <module>
        test2()
    捕获到了异常,信息是:name 'num' is not defined
    ----test3-3---
    
    ------test3执行完了,分割一下------------
    NameError: name 'num' is not defined
    ----test2-1----
    ----test1-1----

    6.开发中异常处理模式

    • 在实际开发中,为了能够处理复杂的异常情况,完整的异常语法如下:
    try:
        # 尝试执行的代码
        pass
    except 错误类型1:
        # 针对错误类型1,对应的代码处理
        pass
    except 错误类型2:
        # 针对错误类型2,对应的代码处理
        pass
    except (错误类型3, 错误类型4):
        # 针对错误类型3 和 4,对应的代码处理
        pass
    except Exception as result:
        # 打印错误信息
        print(result)
    else:
        # 没有异常才会执行的代码
        pass
    finally:
        # 无论是否有异常,都会执行的代码
        print("无论是否有异常,都会执行的代码")
    
    • else 只有在没有异常时才会执行的代码
    • finally 无论是否有异常,都会执行的代码

    7.异常的传递

    • 异常的传递 —— 当 函数/方法 执行 出现异常,会 将异常传递 给 函数/方法 的 调用一方
    • 如果 传递到主程序,仍然 没有异常处理,程序才会被终止
    • 在开发中,可以在主函数中增加 异常捕获
    • 而在主函数中调用的其他函数,只要出现异常,都会传递到主函数的 异常捕获 中
    • 这样就不需要在代码中,增加大量的 异常捕获,能够保证代码的整洁

    需求

    1. 定义函数 demo1() 提示用户输入一个整数并且返回
    2. 定义函数 demo2() 调用 demo1()
    3. 在主程序中调用 demo2()
    def demo1():
        return int(input("请输入一个整数:"))
    
    
    def demo2():
        return demo1()
    
    try:
        print(demo2())
    except ValueError:
        print("请输入正确的整数")
    except Exception as result:
        print("未知错误 %s" % result)

    统一声明:关于原创博客内容,可能会有部分内容参考自互联网,如有原创链接会声明引用;如找不到原创链接,在此声明如有侵权请联系删除哈。关于转载博客,如有原创链接会声明;如找不到原创链接,在此声明如有侵权请联系删除哈。 

    展开全文
  • python中异常处理--raise的使用

    万次阅读 2019-06-06 16:40:58
    当程序出现错误,python会自动引发异常,也可以通过raise显示地引发异常。一旦执行了raise语句,raise后面的语句将不能执行。 raise() 用raise语句来引发一个异常异常/错误对象必须有一个名字,且它们应是Error...
  • Python中异常(Exception)的总结

    千次阅读 2019-07-15 15:13:51
    Python中异常处理 异常处理的语句结构 -------------------------------------------------------------------- 注:如果你对python感兴趣,我这有个学习Python基地,里面有很多学习资料,感兴趣的+Q群:...
  • 想一想假如有个学员信息管理系统,每位学员都有一堆信息需要录入系统,某个学员的信息已经录入了一半还没保存,这时程序突然出现错误异常退出了,那我们前面的那些工作岂不是白做了。所以这个时候我们就需要捕获到...
  • python自定义异常_Python自定义异常

    千次阅读 2020-07-05 22:24:52
    python自定义异常In this tutorial we are going to learn about Python Custom Exception. If you don’t know about Python Exception Handling, we suggest you to ... 在本教程,我们将学习Python自定义异常...
  • python 忽略 异常 什么是例外? (What is an Exception?) An exception is an event, which occurs during the execution of a program that interrupts the normal execution of the application. Generally, any ...
  • Python基础之:Python中异常和错误

    千次阅读 2021-03-29 11:35:42
    和其他的语言一样,Python中也有异常和错误。在 Python ,所有异常都是 `BaseException` 的类的实例。 今天我们来详细看一下Python中异常和对他们的处理方式。
  • python异常处理

    万次阅读 2018-08-10 22:22:36
    python提供了两个非常重要的功能来处理python程序在运行出现的异常和错误。你可以使用该功能来调试python程序。 异常处理: 本站Python教程会具体介绍。 断言(Assertions):本站Python教程会具体介绍。 python标准...
  • Python 自定义异常

    千次阅读 2017-09-28 15:14:25
    Python 提供了丰富的标准异常,这些异常非常灵活,我们甚至可以根据需要进行修改以满足特定需求,所以应该尽可能地使用它们。 然而,在实际编程,你会发现有时标准异常不够用,这就需要我们创建自定义异常来满足...
  • Python - Python异常处理机制

    千次阅读 2014-04-11 17:07:50
    Python异常处理机制 本文地址: http://blog.csdn.net/caroline_wendy/article/details/23459001 Python异常处理机制: try: 尝试抛出异常; raise: 引发异常; except: 处理异常; finally: 是否发生异常都...
  • Python——异常

    千次阅读 2018-09-07 00:55:57
    1. 异常即是一个事件,该事件会在程序执行过程发生,影响了程序的正常执行。  2. 一般情况下,Python无法正常处理程序时就会发生一个异常。 3. 异常Python 对象,表示一个错误。当 Python 脚本发生异常时...
  • python3 异常异常处理

    千次阅读 2017-10-27 22:04:27
    异常@(python3) ...内建异常python3.5 官网手册Exception 所有异常的基类AttributeError 特征引用或者赋值失败时引发的IOError 试图打在不存在的文件(包括其他情况)IndexError 使用序列不存在的索引KeyErro
  • Python traceback捕获并打印异常(Python中异常栈跟踪) 本文转载自Python traceback捕获并打印异常 Python中用于处理异常栈的模块是traceback模块,它提供了 print_exception、format_exception等输出异常栈等...
  • Python常见异常Exception

    千次阅读 2019-01-10 20:59:04
    异常——Python解释器检测到错误时会中止程序执行并报告错误类型 Python中用异常对象表示异常情况,遇到错误时如果异常对象没有被捕捉或处理,则程序会用回溯或跟踪即traceback 查看常见异常类 dir(builtins)...
  • python中assertion异常

    万次阅读 2016-07-23 16:00:18
    python中的assert是一种最简单的异常机制 assert的基本语法是: "assert" expression1 ["," expression2]expression1用于判断生成布尔值,当expression1为假的时候,则抛出异常,[]的内容可选,即用户可以选择...
  • Python异常 ValueError

    万次阅读 2019-03-04 17:08:57
    Python ValueError异常抛出场景和规避方法介绍。
  • Python异常 IndexError

    千次阅读 2019-03-16 11:19:23
    Python IndexError异常抛出场景和规避方法介绍。
  • 一、什么是异常1.错误从软件方面来说,错误是语法或是逻辑上的。错误是语法或是逻辑上的。语法错误指示软件的结构上有错误,导致不能被解释器解释或编译器无法编译。这些些错误必须在程序执行前纠正。当程序的语法...
  • Python中异常处理

    千次阅读 2017-12-17 11:33:07
    注意:本篇博客适用于Python3一、try…except有时候我们写程序的时候,会出现一些错误或异常,导致程序终止。例如,做除法时,除数为0,会引起一个ZeroDivisionError例子:程序代码: a=10 b=0 c=a/b print("done")...
  • python打印异常信息

    千次阅读 2018-05-02 18:45:30
    下面介绍几种python中获取异常信息的方法,这里获取异常(Exception)信息采用try…except…程序结构。如下所示 try: … exceptException, e: … 1、str(e) 返回字符串类型,只给出异常信息,不包括异常信息的...
  • Python标准异常异常处理详解

    千次阅读 2016-12-04 13:45:48
    python提供了两个非常重要的功能来处理python程序在运行出现的异常和错误。你可以使用该功能来调试python程序。 1.异常处理: 本站Python教程会具体介绍。 2.断言(Assertions):本站Python教程会具体介绍。
  • python异常处理

    万次阅读 2020-07-13 04:20:08
    try方法实现python异常处理
  • python中异常

    千次阅读 2012-04-08 20:52:36
    当你的程序出现异常情况时就需要异常处理。比如当你打开一个不存在的文件时。当你的程序有一些无效的语句时,Python会提示你有错误存在。 下面是一个拼写错误的例子,print写成了Print。Python是大小写敏感的,...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 340,390
精华内容 136,156
关键字:

python中的异常

python 订阅